ghc-7.8.4: The GHC API

Safe Haskell | None
Language | Haskell98

TcPat

# Documentation

tcLetPat :: TcSigFun -> LetBndrSpec -> LPat Name -> TcSigmaType -> TcM a -> TcM (LPat TcId, a)

type TcSigFun = Name -> Maybe TcSigInfo

type TcPragFun = Name -> [LSig Name]

data TcSigInfo

Constructors

TcSigInfo |

Fields

sig_id :: TcId
sig_tvs :: [(Maybe Name, TcTyVar)]
sig_theta :: TcThetaType
sig_tau :: TcSigmaType
sig_loc :: SrcSpan

Instances

Outputable TcSigInfo |

findScopedTyVars :: LHsType Name -> TcType -> [TcTyVar] -> [(Maybe Name, TcTyVar)]

data LetBndrSpec

Constructors

LetLclBndr |
LetGblBndr TcPragFun |

addInlinePrags :: TcId -> [LSig Name] -> TcM TcId

warnPrags :: Id -> [LSig Name] -> SDoc -> TcM ()

tcPat :: HsMatchContext Name -> LPat Name -> TcSigmaType -> TcM a -> TcM (LPat TcId, a)

tcPats :: HsMatchContext Name -> [LPat Name] -> [TcSigmaType] -> TcM a -> TcM ([LPat TcId], a)

newNoSigLetBndr :: LetBndrSpec -> Name -> TcType -> TcM TcId

addDataConStupidTheta :: DataCon -> [TcType] -> TcM ()

badFieldCon :: ConLike -> Name -> SDoc

polyPatSig :: TcType -> SDoc